/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
/*-----------------------------------------------------------------------------------
                      Interface    Signal <-->  C++
  Ce fichier contient la définition de toutes les fonctions externes appelees par 
  le programme SIGNAL qui decrit le superviseur de l'editeur graphique de Signal 
  (SUPERVISEUR.SIG ou SUPERVISEUR_body.c).
  Les appels de fonctions externes dans un programme Signal sont des appels à la C.
  Or supervis_sig_g.c qui contient les définitions proprement dites des fonctions
  externes, est un module C++, il a donc fallu interfacer SUPERVISEUR_body.c et 
  supervis_sig_g.c par ce module.
  ---------------------------------------------------------------------------------*/

#include "classReferences.h"
#include "common_type.h"
#include "const_i.h"
#include "string_type.h"
#include "SUPERVISEUR_types.h"
#include "graphicalTypes.h"
#include "tabtools_type.h"
#include "GHDC_type.h"
#include "DCG.h"  
#include "kernel_type.h"
#include "OptionManager.h"
#include "BatchCompiler.h"
#include "supervis.h"
#include "message.h"
#include "interfSignalC_types.h"
#include "interfSignalC_g.h"
#include "LiaisonSignalC2Java_g.h"

static ptSupervis pSupervis;
static ptMessage the_messageTool;

///
extern void initInterfSignalC(ptMessage pMess)
{
  the_messageTool = pMess;
}

///
extern void setInterfSignalC(ptSupervis pSup)
{
  pSupervis = pSup;
}

///
extern boolean r_SUPERVISEUR_HE(boolean *h1)
{
  *h1 = pk_false;
  return(pk_true);
}

///
extern boolean MOUSE_DOWN_IN_GE(boolean b)
{
  return(pSupervis->MOUSE_DOWN_IN_GE());
}

/// Paul remplace APPUI_BOUTON
extern int ReadMenuButton()
{
  return(pSupervis->ReadMenuButton());
}

///
extern boolean SAVE_DOWN(boolean)
{
  return(pSupervis->SAVE_DOWN());
}
 
///
extern boolean BUILD_RESOLV_DOWN(boolean)
{
  return(pSupervis->BUILD_RESOLV_DOWN());
}
 
///
extern void GET_OBJ(int x, int y, int *obj, objet_type *typ_obj)
{
  pSupervis->GET_OBJ(x , y , obj , typ_obj);
}

///
extern void GET_XY(mouse_type e, int *x, int *y)
{
  pSupervis->GET_XY(e , x , y);
}

///
extern ntrees getSelectedProc()
{
  return(pSupervis->getSelectedProc());
}

///
extern mouse_type GET_BUTTON(boolean)
{
  return(pSupervis->GET_BUTTON());
}

///
extern boolean PASTE_BOITE(void)
{
  return(pSupervis->PASTE_BOITE());
}

///
extern void PASTING(int action, int x, int y)
{
  pSupervis->PASTING(action , x , y);
}

///
extern void COPYING(int x, int y)
{
  pSupervis->COPYING(x , y);
}


///
extern void CREATION_BOITE(int x, int y, int action)
{
  pSupervis->CREATION_BOITE(x , y , action);
}

///
extern void CREATION_LIEN(int x, int y)
{
  pSupervis->CREATION_LIEN(x , y);
}

///
extern void CREATION_PORT(int x, int y)
{
  pSupervis->CREATION_PORT(x , y);
}

///
extern void JUSTIFYING(int but, int etat, int x, int y)
{
  pSupervis->JUSTIFYING(but , etat , x , y);
}

///
extern void GLUING(int action, int x, int y)
{
  pSupervis->GLUING(action , x , y);
}

///
extern void RESIZING(int action, int x, int y)
{
  pSupervis->RESIZING(action , x , y);
}

///
extern void MOVING(int action, int x, int y)
{
  pSupervis->MOVING(action , x , y);
}

///
extern void BREAKING(int x, int y)
{
  pSupervis->BREAKING(x , y);
}

///
extern void CUTTING(int x, int y)
{
  pSupervis->CUTTING(x, y);
}

///
extern void razSelectBuf()
{
  pSupervis->razSelectBuf();
}

///
extern void SELECTING(int x, int y)
{
  pSupervis->SELECTING(x , y);
}

///
extern void MAPPING_BTE(int x, int y)
{
  pSupervis->MAPPING_BTE(x , y);
}

///
extern void END_MAPPING()
{
  pSupervis->END_MAPPING();
}

///
extern void MAPPING_LIEN(int but, int etat, int x, int y)
{
  pSupervis->MAPPING_LIEN(but , etat , x , y);
}

///
extern void changeModelCat(ntrees t, action_type ty_ch)
{
  pSupervis->changeModelCat(t , ty_ch);
}

///
extern void RECUP_IDENTS(ptident *ident1, ptident *ident2)
{
  pSupervis->RECUP_IDENTS(ident1 , ident2);
}

///
extern void REPLACING_IDENT(ntrees p,  ptident ident1, ptident ident2)
{
  pSupervis->REPLACING_IDENT(p, ident1, ident2);
}

///
extern void SEE_PROFIL(int obj)
{
  pSupervis->SEE_PROFIL(obj);
}

///
extern void SHOW_HALO(int obj, objet_type typ_obj)
{
  pSupervis->SHOW_HALO(obj , typ_obj);
}

///
extern boolean PASSER_PORT(int passe)
{
  return(pSupervis->PASSER_PORT(passe));
}

///
extern boolean VALIDER_PORT(int x, int y, int obj, objet_type typ_obj)
{
  return(pSupervis->VALIDER_PORT(x , y , obj , typ_obj));
}

///
extern void GO_UP(int remonte)
{
  pSupervis->GO_UP(remonte);
}

///
extern boolean GO_DOWN(int obj)
{
  return(pSupervis->GO_DOWN(obj));
}

///
extern void DISPLAYING_PRAGMAS()
{
  pSupervis->DISPLAYING_PRAGMAS();
}

///
extern void seeingParam(ntrees p)
{
  pSupervis->seeingParam(p);
}

///
extern void CREATING_SPEC(ntrees p)
{
  pSupervis->CREATING_SPEC(p);
}

///
extern void seeingLocDecl(ntrees p)
{
  pSupervis->seeingLocDecl(p);
}

///
extern void seeingInOut(ntrees p)
{
  pSupervis->seeingInOut(p);
}

///
extern void AFFICHAGE(action_type action)
{
  pSupervis->AFFICHAGE(action);
}

///
extern void TRACE(char * message, action_type action)
{
  pSupervis->TRACE(message, action);
}

///
extern void UNDOING()
{
  pSupervis->UNDOING();
}

///
extern void REFRESHING()
{
  pSupervis->REFRESHING();
}

///
extern void WINDOW_TEXTING()
{
  pSupervis->WINDOW_TEXTING();
}

///
extern action_type CONFIRMING()
{
  return(pSupervis->CONFIRMING());
}

///
extern void DISPLAYING_POLICE(action_type act)
{
  pSupervis->DISPLAYING_POLICE(act);
}

///
extern void DISPLAYING_NAMES(boolean nom_port)
{
  pSupervis->DISPLAYING_NAMES(nom_port);
}

///
extern void DISPLAYING_DETAILS(boolean detail)
{
  pSupervis->DISPLAYING_DETAILS(detail);
}


///
extern void EMBEDDED_CREATING(integer bte, ntrees *t, boolean *ok)
{
  pSupervis->EMBEDDED_CREATING(bte , t , ok);
}

///
extern boolean IS_ROOT() { return(pSupervis->IS_ROOT());}

///
extern boolean IS_MODULE() { return(pSupervis->IS_MODULE());}

///
extern ntrees GET_RACINE()
{
  return(pSupervis->GET_RACINE());
}

///
extern ntrees getCurrentModel()
{
  return(pSupervis->GET_PROC_COU());
}

///
extern ntrees ARCHI_BUILD(ntrees p_proc)
{
  return(pSupervis->ARCHI_BUILD(p_proc));
}
 
///
extern void PRE_COMP(ntrees p_a_compiler, integer typ_comp, 
		     ntrees *p_copie, boolean *err, boolean *ok)
{
  pSupervis->PRE_COMP(p_a_compiler, typ_comp, p_copie, err, ok);
}

///
extern void GRAPH_BUILD(ntrees p, typeDCG *igraph, boolean *err)
{
  ptDCG_basic gb;
  pSupervis->GRAPH_BUILD(p, &gb, err);
  (*igraph) = (typeDCG) gb;
}

///
extern void WIN_DISPLAY_AUTO(boolean)
{
  pSupervis->WIN_DISPLAY_AUTO();
}

///
extern void WIN_DISPLAY(boolean)
{
  pSupervis->WIN_DISPLAY();
}

///
extern void GET_FUNC(function_type *func, boolean *b)
{
  pSupervis->GET_FUNC(func , b);
}

///
extern void ALLOWED_FUNC_DISPLAY(DCGLevel state)
{
  pSupervis->ALLOWED_FUNC_DISPLAY(state);
}

///
extern boolean Retiming(typeDCG vgraph, DCGLevel level)
{
  // tester level
  return(pSupervis->moveIn2OutDelays((ptDCG_basic) vgraph));
}

///
extern boolean BooleansEvents(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->BooleansEvents((ptDCG_basic) vgraph));
}

///
extern boolean ClockCalcul(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->ClockCalcul((ptDCG_poly) vgraph));
}

///
extern boolean trainsCalculus(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->trainsCalculus((ptDCG_bool) vgraph));
}

///
extern void BuildAbstraction(typeDCG vgraph, DCGLevel level, boolean *b, typeDCG  *gBool)
{
  ptDCG_bool g;

  (*b) = pSupervis->BuildAbstraction((ptDCG_poly) vgraph, &g);
  (*gBool) = (typeDCG)g;
}

///
extern boolean mkProfiling(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->mkProfiling(( ptDCG_poly) vgraph));
}


///
extern boolean InterfaceCalculus(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->InterfaceCalculus( (ptDCG_poly) vgraph));
}

///
extern boolean Pruning(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->Pruning((ptDCG_basic) vgraph));
}

///
extern boolean transitiveClosure(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->transitiveClosure((ptDCG_basic) vgraph));
}

///
extern boolean ClockEnvBuilding(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->ClockEnvBuilding((ptDCG_poly) vgraph));
}

///
extern boolean CycleDetection(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->CycleDetection( ( ptDCG_bool ) vgraph));
}

///
extern void DCGBool2DCGSeq(typeDCG vgraph, boolean *b, typeDCG *gs)
{
  ptDCG_sch gSeq;
  (*b) = pSupervis->totallyOrder(( ptDCG_bool ) vgraph, &gSeq);
  (*gs) = (typeDCG) gSeq;
}

///
extern void DCGBool2DCGFlat(ptDCG_bool vgraph, boolean *b,typeDCG *gs)
{
  ptDCG_flat gf; 
  (*b) = pSupervis->DCGBool2DCGFlat(vgraph, &gf);
  (*gs) = (typeDCG) gf;
}


///
extern void DCGBasic2DCGPoly(typeDCG gb, boolean *b,typeDCG *gs)
{
  ptDCG_poly gp;
  (*b) = pSupervis->DCGBasic2DCGPoly((ptDCG_basic) gb, &gp);
  (*gs) = (typeDCG) gp;
}


extern void DCGPoly2DCGEndo(typeDCG gb, boolean *b,typeDCG *gs)
{
  ptDCG_endo gp;
  (*b) = pSupervis->DCGPoly2DCGEndo((ptDCG_poly) gb, &gp);
  (*gs) = (typeDCG) gp;
}


extern void DCGEndo2DCGBool(typeDCG gb, boolean *b, typeDCG *gs)
{
  ptDCG_bool gp;
  (*b) = pSupervis->DCGEndo2DCGBool((ptDCG_endo) gb, &gp);
  (*gs) = (typeDCG) gp;
}

extern void DCGPoly2DCGBool(typeDCG gp, boolean *b, typeDCG *gs)
{
  ptDCG_bool gb;
  (*b) =  pSupervis->DCGPoly2DCGBool((ptDCG_poly) gp, &gb);
  (*gs) = (typeDCG) gb;
}

///
extern boolean GenSignal(typeDCG vgraph, DCGLevel level)
{
  return pSupervis->GenSignal((ptDCG_poly) vgraph);
}

///
extern boolean GenC(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->GenC((ptDCG_sch) vgraph));
}

///
extern boolean GenCseparate(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->GenCseparate((ptDCG_sch) vgraph));
}

///
extern boolean GenCPP(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->GenCPP((ptDCG_sch) vgraph));
}

///
extern boolean GenJAVA(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->GenJAVA((ptDCG_sch) vgraph));
}

///
extern boolean GenZ3z(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->GenZ3z((ptDCG_poly) vgraph));
}

///
extern boolean GenSyndexCode(typeDCG vgraph, DCGLevel level)
{
  return(pSupervis->GenSyndexCode((ptDCG_flat) vgraph));
}

///
extern void PartitioningRunOn(typeDCG vgraph, DCGLevel level)
{
  pSupervis->PartitioningRunOn( (ptDCG_bool) vgraph);
}

///
extern void END_COMP(boolean)
{
  pSupervis->END_COMP();
}

///
extern void END_COMP_ERR(boolean)
{
  pSupervis->END_COMP_ERR();
}

///
extern void END_COMP_EMBED(ntrees p_proc_embed)
{
  pSupervis->END_COMP_EMBED(p_proc_embed);
}

///
extern void END_COMP_ERR_EMBED(ntrees p_proc_embed)
{
  pSupervis->END_COMP_ERR_EMBED(p_proc_embed);
}

///
extern void END_COMP_ARCHI(ptDCG_bool vgraph)
{
  pSupervis->END_COMP_ARCHI(vgraph);
}

///
extern void END_COMP_ERR_ARCHI(boolean)
{
  pSupervis->END_COMP_ERR_ARCHI();
}

///
extern void PRINTING(boolean b)
{
  pSupervis->PRINTING(b);
}

///
extern void saveFile(int act,  boolean isGraphic)
{
  pSupervis->LOCAL_SAVING(act,isGraphic);
}

///
extern void CALLING_PROVER()
{
  pSupervis->CALLING_PROVER();
}

///
extern void BUILDING_RESOLV()
{
  pSupervis->BUILDING_RESOLV();
}
  
///
extern boolean loadFile(int act, boolean isGraphic)
{
  return pSupervis->LOADING(act,isGraphic); // may display error messages
}
 
///
extern void CACHE_TEXTE(boolean b)
{
  pSupervis->CACHE_TEXTE();
}

///
extern void ANNULATION(int on_efface)
{
  pSupervis->ANNULATION(on_efface);
}

///
extern void GET_COMPILING_MOD(ptDCG_basic, boolean *bauto, boolean *bdirect)
{
  pSupervis->GET_COMPILING_MOD(bauto, bdirect);
}

///
extern boolean AUTO_COMPILING_ACTIONS(ptDCG_basic g)
{
  return(pSupervis->AUTO_COMPILING_ACTIONS(g));
}

///
extern boolean DIRECT_COMPILING(ptDCG_basic g)
{
  return(pSupervis->DIRECT_COMPILING(g));
}


///
extern boolean EMBEDDED_COMPILING(ntrees vt)
{
  return(pSupervis->EMBEDDED_COMPILING(vt));
}

///
extern boolean Unifications(ptDCG_basic vgraph)
{
  return(pSupervis->Unifications(vgraph));
}

///
extern boolean GenSignalAbs(ptDCG_bool vgraph)
{
  return(pSupervis->GenSignalAbs(vgraph));
}

///
extern void END_OF_FUNCTIONALITY(boolean b)
{
  pSupervis->END_OF_FUNCTIONALITY();
}


///
extern void COPYING_ICON(int x, int y)
{
  pSupervis->COPYING_ICON(x , y);
}

///
extern void DISPLAYINGINFO_ICON()
{
  pSupervis->DISPLAYINGINFO_ICON();
}

///
extern void removeLib()
{
  pSupervis->removeLibrary();
}

///
extern void reloadLib()
{
  int status = pSupervis->reloadLibrary(); // status among ERR_readableFile, ERR_gpkFileContent, statusOK
  if ( status == statusOK )
    return;
  the_messageTool->error_mess(status);
}

///
extern void HELPMESS()
{
  the_messageTool->HELPMESS();
}

extern void PostscriptPrint()
{
  C2Java_PostscriptPrint();
}

extern void displayConfirm(int action)
{
  C2Java_displayConfirm(action);
}

extern void quitApplication()
{
  C2Java_quitApplication();
}

extern boolean getDetailState()
{
  return C2Java_getDetailState();
}

extern boolean getNamesState()
{
  return C2Java_getNamesState();
}
