/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */


// Lbesnard : porting on windows.
// variant array : not accepted by visual C++.
// It was used in the procedure : C2Java_drawPolyline, FillPolygon, C2Java_drawPolygon
// C2Java_drawPolyline is called with nb = 2; and FillPolygon, C2Java_drawPolygon with nb=3.
// the declarations have been replaced by tamponXX[_ARRAY_MAX_SIZE_]

#define _ARRAY_MAX_SIZE_ 10

#define J_CanvasText 1
#define J_HierarText 2
#define J_DiagComp 3
#define J_ParamText 4

///
static JNIEnv *currentEnv;/**variable d'environnement JNI*/
static jobject currentObj;/**variable identifiant l'objet possedant les methodes*/
static jclass currentCls; /**variable identifiant la classe de l'objet currentObj */
static jmethodID mid;
///
static jmethodID mid_Refresh;
///
static jmethodID mid_DrawPolyline;
///
static jmethodID mid_DrawLine;
///
static jmethodID mid_FillPolygon;
///
static jmethodID mid_DrawPolygon;
///
static jmethodID mid_C2Java_FillRectangle;
///
static jmethodID mid_DrawRectangle;
///
static jmethodID mid_DrawString;
///
static jmethodID mid_DrawImage;
///
static jmethodID mid_C2Java_readMenuButton;
///
static jmethodID mid_C2Java_razMenuButton;
///
static jmethodID mid_C2Java_getCompilerFunctionality;
///
static jmethodID mid_C2Java_displayFont;
///
static jmethodID mid_C2Java_getSizeFontH;
///
static jmethodID mid_C2Java_getSizeFontL;
///
static jmethodID mid_C2Java_helpShow;
///
static jmethodID mid_C2Java_showNamePort;
///
static jmethodID mid_C2Java_displayCurrentAction;
///
static jmethodID mid_C2Java_resetMoveMouseEvent;

///
char cchaine[256];

///
int
  supervis::select_buffer[TBS];

///
static
  ptGraphicTrees
  pGraphArb;
///
static
  ptGraphicTablesManager
  the_graphicTablesManager;
///
static
  ptMessage
  pMess;

///
static void
setCurrentEnv (JNIEnv * env, jobject obj)
{
  currentEnv = env;
  currentObj = obj;
  if (obj != (jobject) null)
    {
      currentCls = env->GetObjectClass (obj);
      mid_Refresh = currentEnv->GetMethodID (currentCls, "refresh", "(Z)V");
      mid_DrawPolyline = currentEnv->GetMethodID (currentCls, "drawPolyline", "([I[IIII)V");
      mid_DrawLine = currentEnv->GetMethodID (currentCls, "drawLine", "(IIIIII)V");
      mid_FillPolygon = currentEnv->GetMethodID (currentCls, "fillPolygon", "([I[IIII)V");
      mid_DrawPolygon = currentEnv->GetMethodID (currentCls, "drawPolygon", "([I[IIII)V");
      mid_DrawRectangle = currentEnv->GetMethodID (currentCls, "drawRectangle", "(IIIIII)V");
      mid_C2Java_FillRectangle = currentEnv->GetMethodID (currentCls, "fillRectangle", "(IIIII)V");
      mid_DrawString = currentEnv->GetMethodID (currentCls, "drawString", "(Ljava/lang/String;IIII)V");
      mid_DrawImage = currentEnv->GetMethodID (currentCls, "drawImage", "(Ljava/lang/String;II)V");
      mid_C2Java_getCompilerFunctionality = currentEnv->GetMethodID (currentCls, "getCompilerFunctionality", "()I");
      mid_C2Java_displayFont = currentEnv->GetMethodID (currentCls, "displayFont", "()V");
      mid_C2Java_getSizeFontH = currentEnv->GetMethodID (currentCls, "getSizeFontH", "(I)I");
      mid_C2Java_getSizeFontL = currentEnv->GetMethodID (currentCls, "getSizeFontL", "(I)I");
      mid_C2Java_helpShow = currentEnv->GetMethodID (currentCls, "helpShow", "()V");
      mid_C2Java_showNamePort = currentEnv->GetMethodID (currentCls, "showNamePort", "(Ljava/lang/String;)V");
      mid_C2Java_displayCurrentAction = env->GetMethodID (currentCls, "displayCurrentAction", "(I)V");
      mid_C2Java_resetMoveMouseEvent = currentEnv->GetMethodID (currentCls, "resetMoveMouseEvent", "()V");
    }
}

#define MAXSTACK 10

///
typedef struct
{
  JNIEnv *
    env;
  jobject
    obj;
}				///
elem;

///
static
  elem
  stack[MAXSTACK];
///
static int
  indStack;

///
static void
initStack (void)
{
  indStack = 0;
}

///
static void
push (JNIEnv * env, jobject obj)
{
  stack[indStack].env = currentEnv;
  stack[indStack].obj = currentObj;
  indStack++;
  setCurrentEnv (env, obj);
}

///
static void
pop (void)
{
  indStack--;
  currentEnv = stack[indStack].env;
  currentObj = stack[indStack].obj;
  setCurrentEnv (currentEnv, currentObj);
}


///
static char *
copyString (const char *str, int size)
{
  char *
    c_name;
  int
    i;
  c_name = (char *) malloc (size + 1);
  for (i = 0; i < size; i++)
    c_name[i] = str[i];
  c_name[size] = '\0';
  return c_name;
}

static char *
javaString2CString (JNIEnv * env, jstring name)
{
  const char *
    str = (env)->GetStringUTFChars (name, 0);
  int
    size = (env)->GetStringUTFLength (name);
  char *
    c_name = copyString (str, size);
  return c_name;
}

///
static void
mkJintArray (int x[], int nb, jint tamponx[])
{
  int
    i;
  for (i = 0; i < nb; i++)
    tamponx[i] = (jint) x[i];
}
