/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
//
// Fonction appelée pour la synthèse de controleur, lorsqu'on clique sur le bouton include resolv
// (sous menu prove).
//      construit un appel à RESOLVER
//      rajoute tous les codages nécessaires.
///
EXTERN void
buildResolv (ntrees p_proc, ptGraphicTrees pGrArb, ptGraph_text pGrText, ptMessage pMess, ptrepbuf filebuf)
{
  ptrepstr strNameProc, fileName;
  ntrees p_root, lDecl, p_expr, p_resolv, pName;

  pGraph_arb = pGrArb;
  p_root = pGrArb->getRootProc (p_proc);	// p_root: tout le programme sans le process environment
  strNameProc = STreeModelModule_getNameStr (p_root);
  lDecl = STreeModel_getLocalDeclarations (p_proc);
  pName = LL_make_nom_atom (string2repstr ("RESOLVER"));
  if (pGrArb->isModelInList (pName, lDecl, &p_resolv))
    {
      initResolv (pMess, pGrText, strNameProc);
      // on construit le codage et les differents appels au resolveur 
      p_expr = STreeModel_getBody (p_proc);
      if (traiter_fich_sigali (nom_fich_sigali, p_expr))
	{			/* PLG change 2010-01-10: opinteger removed */
	  creer_decl_IO_model (p_root, p_proc);
	  creer_appel_resolv (p_expr);
	  creer_decl_codage (lDecl, nb_sort, chaine_U);
	  creer_decl_codage (lDecl, taille_vect_etat, chaine_X);
	  creer_decl_codage (lDecl, taille_vect_cond, chaine_cond);
	  creer_decl_codage (lDecl, taille_vect_mesu, chaine_Y);
	  creer_decl_interm (lDecl, taille_vect_etat, chaine_INTERM);
	  // on décompile textuellement dans un fichier qui a pour nom strNameProc".SIG"
	  pGraph_text->completeTree (p_root);
	  filebuf->setsize (margeGaucheMax, lgligne);
	  if (!strconc2str (strNameProc, string2repstr (".SIG"), pk_false, &fileName))
	    fileName = strNameProc;
	  if (pK_SignalPrinter->fileUnparse (p_root, filebuf, fileName, 1000, ofile))
	    {
	      // Nettoyage de tout ce qui a été rajouté dans le programme durant cette passe
	      pGraph_text->cleanMarkedTree (p_root);
	      the_messageTool->info_mess (endBuildFile);
	    }
	}
      else
	the_messageTool->error_mess (ERR_fileOpening);
      //      strregfree(reg);
    }
  else
    the_messageTool->error_mess (errBuildResolv);
}
