/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
///
_PRIVATE_
/*
  Fonction appelée lorsqu'on fait un "undo" après avoir rentré du texte Signal.
*/
  void
undo::set_undo_text ()
{
  ntrees arb_port, p_bte, p_save, arb_cou, proc_cou;
  objet_type t;

  arb_cou = pCurObjManager->get_arb_cou_engl ();
  proc_cou = pCurObjManager->getModelInWhich_cou_engl ();
  p_save = info_undo.arb_recup;
  nmakeattrntrees (p_save, GRAPHI_ATTRNUMBER, info_undo.attr_recup);
  t = info_undo.typ_obj_recup;
  if ((t == typ_text_nom_proc) || (t == typ_text_param_proc))
    {
      if (t == typ_text_nom_proc)	/* boite nom du processus */
	STree_replaceSon (arb_cou, p_save, 1);
      else
	STree_replaceSon (nchild (2, arb_cou), p_save, 1);
      the_graphicalTrees->reconstruire_tab (p_save, pk_true, pk_false, 0, 0);
    }
  else
    {
      if (arb_cou != proc_cou)
	STree_replaceSon (arb_cou, p_save, info_undo.recup_rg);
      else
	STree_replaceSon (STreeModel_getBody (proc_cou), p_save, 0);
      the_graphicalTrees->reconstruire_tab (p_save, pk_true, pk_false, 0, 0);
      p_bte = info_undo.attr_recup;
      arb_port = the_graphicalTrees->getFirstPort (p_bte);
      while (arb_port != null)
	{
	  if ((noper (arb_port) == gpkOp_porte) && (nchild (3, arb_port) != null))
	    the_graphicalTrees->repositionner_liens (nchild (3, arb_port));
	  arb_port = ntrees_getNext (arb_port);
	}
    }
}


/**
  Fonction appelée après avoir modifié l'interface d'une boite,
  c'est-à-dire les déclarations associées à ses ports.
*/
void
undo::set_undo_profil ()
{
  ntrees proc_cou, arb_cou;

  proc_cou = pCurObjManager->getModelInWhich_cou_engl ();
  arb_cou = pCurObjManager->get_arb_cou_engl ();
  nmakeattrntrees (info_undo.arb_recup, GRAPHI_ATTRNUMBER, info_undo.attr_recup);
  the_graphicalTrees->reconstruire_tab (info_undo.arb_recup, pk_true, pk_false, 0, 0);
  if (ISNOT_NILTREE (info_undo.arb_recup_inte))
    STree_replaceInputsOutputs (proc_cou, info_undo.arb_recup_inte);
}


/**
    A VERIFIER SI CETTE FONCTION EST APPELEE
*/
void
undo::set_undo_proc ()
{
  ntrees p_proc;

  fprintf (stderr, "processus à sauver \n");
  p_proc = info_undo.arb_recup;
  if (pCurObjManager->get_racine () != pCurObjManager->get_arb_cou_engl ())
    {
      the_graphicalTrees->reconstruire_tab (p_proc, pk_true, pk_false, 0, 0);
      STree_replaceSon (pCurObjManager->get_arb_cou_engl (), p_proc, 0);
      pCurObjManager->set_bte_cou_engl (the_graphicalTrees->get_arb_boite (p_proc));
    }
  else
    {
      the_graphicalTrees->reconstruire_tab (p_proc, pk_true, pk_false, 0, 0);
      pCurObjManager->set_racine (p_proc);
      pCurObjManager->set_bte_cou_engl (NILTREE);
    }
  pCurObjManager->set_arb_cou_engl (p_proc);
  pCurObjManager->set_proc_cou_engl (p_proc);
}
