 /*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */


 

// ERROR CODE
public class Constants {
    public final static int MAX_LENGTH_STRING_SIGNAL_PARSER = 256; // MaxLenghtString : SIGNAL parser limit (implementation restriction). (before MaxLenghtString)
    public final static int MAX_OPENED_TWINDOWS= 64; // maximum of text windows that can be opened at the same time.  (before  nbGW )
    public final static int MAX_OPENED_RWINDOWS= 16; // maximum of Rwindows that can be opened at the same time.  (before  nbGW )
    public final static int MAX_OPENED_CWINDOWS= 8; // maximum of children Cwindows that can be opened at the same time in the same Pwindow.  (before  nbGW )
    public final static String[] ERRORS_TAB = new String[58];


// ERROR CODE
    public static final int  J_statusOK = 0;
    public static final int  J_ERR_fileSaving = 19;
    public static final int  J_ERR_fileOpening = 20;
    public static final int  J_ERR_noGarbage = 25;
    public static final int  J_ERR_readableFile = 28;
    public static final int  J_ERR_LibraryContent = 51;
    public static final int  J_ERR_notExistFile = 52;
    public static final int  J_ERR_gpkFileContent = 53;
    public static final int  J_ERR_parsing = 54;
    public static final int  J_ERR_unparseFile = 56;
    public static final int  J_ERR_insertModule = 57;

    static {
        ERRORS_TAB[0] = "";
        ERRORS_TAB[1] = "Box creation failure : intersection conflict ";
        ERRORS_TAB[2] = "Link creation failure: intersection conflict ";
        ERRORS_TAB[3] = "Link creation failure: double connection to a port ";
        ERRORS_TAB[4] = "Link creation failure: port conflict";
        ERRORS_TAB[5] = "Failure: objects conflict";
        ERRORS_TAB[6] = "Moving failure: intersection conflict";
        ERRORS_TAB[7] = "To map a link : click first, a link, then two ports";
        ERRORS_TAB[8] = "Moving port failure";
        ERRORS_TAB[9] = "Link mapping failure : try again!";
        ERRORS_TAB[10] = "Access to nesting structure failure: top level ";
        ERRORS_TAB[11] = "Automatic routing failure: select intermediate points ";
        ERRORS_TAB[12] = "Automatic routing failure during port moving ";
        ERRORS_TAB[13] = "Syntax error  ";
        ERRORS_TAB[14] = "Text creation failure: objects conflict ";
        ERRORS_TAB[15] = "Select a side of the right box for this output ";
        ERRORS_TAB[16] = "Port creation failure: select a side of the right box ";
        ERRORS_TAB[17] = "Input port creation failure: port conflict, try again ";
        ERRORS_TAB[18] = "Output or parameter creation failure: port conflict, try again";
        ERRORS_TAB[19] = "Saving file failure: file system";
        ERRORS_TAB[20] = "Opening file failure: file system";
        ERRORS_TAB[21] = "Compile failure: nameless process ";
        ERRORS_TAB[22] = "Please, select boxes before mapping ";
        ERRORS_TAB[23] = "Anbiguity: a receiver port may be connected with several transmitter ports;          Please, connect yourself these ports.";
        ERRORS_TAB[24] = "Link creation failure: external port connection not allowed";
        ERRORS_TAB[25] = "Memory garbage: not implemented: save files and reset Polychrony";
        ERRORS_TAB[26] = "Tree memory full:save files and reset polychrony";
        ERRORS_TAB[27] = "Write the process external graph in the text window             and then, confirm. ";
        ERRORS_TAB[28] = "File reading failed";
        ERRORS_TAB[29] = "Nesting failure: intersection conflict";
        ERRORS_TAB[30] = "Nesting failure: empty area";
        ERRORS_TAB[31] = "Nesting failure: automatic routing failed";
        ERRORS_TAB[32] = "Nesting failure: automatic port creation failed";
        ERRORS_TAB[33] = "Resizing failure: intersection conflict";
        ERRORS_TAB[34] = "Resizing failure: automatic routing failed";
        ERRORS_TAB[35] = "Unnesting failure: too small nested boxes";
        ERRORS_TAB[36] = "Unnesting failure: no nested box";
        ERRORS_TAB[37] = "Unnesting failure: automatic routing failed";
        ERRORS_TAB[38] = "Unnesting failure: not enough space between some internal ports";
        ERRORS_TAB[39] = "Compile failure: no selected process or module";
        ERRORS_TAB[40] = "WARNING: Not all the ports have been created: the box is too small";
        ERRORS_TAB[41] = "WARNING: automatic routing failed for one of the ports";
        ERRORS_TAB[42] = "Not allowed to do an embedded compiling with the clicked box.  Consult the help!";
        ERRORS_TAB[43] = "WARNING: some links have been created without routing";
        ERRORS_TAB[44] = "Box paste failure: intersection conflict or not enough space between ports";
        ERRORS_TAB[45] = "Useless : the current model has already this type";
        ERRORS_TAB[46] = "Your process cannot be an architecture process, sorry!";
        ERRORS_TAB[47] = "Sorry, this link cannot be moved";
        ERRORS_TAB[48] = "Action not allowed";
        ERRORS_TAB[49] = "Build of the file terminated";
        ERRORS_TAB[50] = "RESOLVER process not found";
        ERRORS_TAB[51] = "Loaded file is not a library";
        ERRORS_TAB[J_ERR_notExistFile] = "Opening file failure: file not found";
        ERRORS_TAB[53] = "Loading file failure: file is too large or it does not contain a signal graph object";
        ERRORS_TAB[54] = "Parsing file failure";
        ERRORS_TAB[55] = "Internal error: Unexpected action is required";
        ERRORS_TAB[56] = "Unparse failed";
        ERRORS_TAB[J_ERR_insertModule] = "Cannot insert a module in a model or a module";
    }
}
