 /*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */


 

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


public class InfoWindow extends JFrame {
    private static final long serialVersionUID = 1L;
    private Font VFONT;
    private Color VCOLOR;
    private static JMenuBar mb;
    private JTextArea textArea;

    public InfoWindow(String motherIdent, int sizex, int sizey, int locx, int locy) {
        Container frame;
        frame = getContentPane();

        setSize(sizex, sizey);
        setLocation(locx, locy);
        VFONT = new Font("Serif", Font.PLAIN, 12);
        VCOLOR = Color.white;
        setTitle(motherIdent+"::Comments");
        textArea = new JTextArea();
        textArea.setLineWrap(true);
        textArea.setWrapStyleWord(true);
        textArea.setEditable(false);
        textArea.setFont(VFONT);
        textArea.setBackground(VCOLOR);
        JScrollPane scroll = new JScrollPane(textArea);
        JMenu styleMenu = createStyleMenu();
        mb = new JMenuBar();
        mb.add(styleMenu);
        frame.add(scroll);
        frame.add(mb, BorderLayout.NORTH);
        setVisible(true);

    }

    protected JMenu createStyleMenu() {
        JMenuItem vItemMenu;

        JMenu menu = new JMenu("Style");
        vItemMenu = new JMenuItem("Choose Font");
        vItemMenu.addActionListener(new InfoWindowListerner(this, textArea, 1));
        menu.add(vItemMenu);

        vItemMenu = new JMenuItem("Choose Color");
        vItemMenu.addActionListener(new InfoWindowListerner(this, textArea, 2));
        menu.add(vItemMenu);

        return menu;
    }

    public void append(String s) {
        textArea.append(s);
    }

    public void resetText() {
        textArea.setText("");
    }

    public String getText() {
        return (textArea.getText());
    }

    public int getColumns() {
        return ((int) (textArea.getSize().getWidth()));
    }

    public JTextArea getTextArea() {
        return textArea;
    }

    public void setCaretPosition(int n) {
        textArea.setCaretPosition(n);
    }
}

class InfoWindowListerner implements ActionListener {
    int userAction;
    JTextArea textArea;
    InfoWindow vinfoWindow;

    InfoWindowListerner(InfoWindow win, JTextArea x, int noAct) {
        textArea = x;
        userAction = noAct;
        vinfoWindow = win;
    }

    public void actionPerformed(ActionEvent event) {
        switch (userAction) {
        case 1:
	    /* ChooseFontInfo f =*/ new ChooseFontInfo(vinfoWindow, textArea.getFont());
            break;
        case 2:
	    /* FrameTextColorChooser c1 = */ new FrameTextColorChooser(vinfoWindow);
	    /* FrameBGColorChooser c2 = */ new FrameBGColorChooser(vinfoWindow);
            break;
        }

    }
}
