 /*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */


 

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.print.PageFormat;
import java.util.Date;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;


public class PrintWindow extends JFrame implements ItemListener {
    private static final long serialVersionUID = 1L;
    private ButtonGroup group = new ButtonGroup();
    private JRadioButton landscape;
    private JRadioButton portrait;
    private JTextArea haut = new JTextArea(1, 30);
    private JTextArea bas = new JTextArea(1, 30);
    private GraphCanvas gC;
    private int format = PageFormat.LANDSCAPE;
    private Date date = new Date();

    private Color getMyColor1() {
        return pKGUIColors.Color1;
    }

    public PrintWindow(GraphCanvas g, String nomProcess) {
        gC = g;
        setTitle("Print");
        setVisible(true);
        setSize(200, 150);
        setLocation(400, 300);
	haut.append(nomProcess);
        bas.append(date.toString());
        // Global Panel
        JPanel panel = new JPanel();
        getContentPane().add(panel);
        panel.setLayout(new BorderLayout());
        panel.setBorder(new EmptyBorder(new Insets(15, 15, 15, 15)));
        // Color of the background of the window
        panel.setBackground(getMyColor1());

	// Panel to set the text
	// JPanel panelArea = new JPanel();
	// panelArea.setLayout(new FlowLayout()); 
	// panelArea.setBackground(getMyColor1());
	// JLabel textHaut = new JLabel ("Upper Text :");
	// textHaut.setBackground(getMyColor1());
	// panelArea.add(textHaut);
	// panelArea.add(haut); panelArea.add(textBas);
	// JLabel textBas = new JLabel("Lower Text :");
	// textBas.setBackground(getMyColor1());
	// panelArea.add(textBas);
	// panel.add(panelArea,BorderLayout.CENTER);
	
        // Panel Choice Portrait or Landscape
        JPanel panelCheck = new JPanel();
        panelCheck.setLayout(new BorderLayout());
        panelCheck.setBackground(getMyColor1());
	landscape = new JRadioButton("Landscape", true);
        landscape.setBackground(getMyColor1());
	portrait = new JRadioButton("Portrait", false);
        portrait.setBackground(getMyColor1());
        panelCheck.add(landscape, BorderLayout.NORTH);
        panelCheck.add(portrait, BorderLayout.SOUTH);
        group.add(landscape); // Join the two radio button in the same group
        group.add(portrait); // Join the two radio button in the same group
        panel.add(panelCheck, BorderLayout.NORTH);

        // Panel Button
        JPanel panelButton = new JPanel();
        panelButton.setLayout(new BorderLayout());
        panelButton.setBackground(getMyColor1());
        panelButton.setBorder(new EmptyBorder(new Insets(5, 5, 5, 5)));

        JButton ok = new JButton("OK");
        ActionListener actOk = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    setVisible(false);
		    if (landscape.isSelected())
			format = PageFormat.LANDSCAPE;
		    else if (portrait.isSelected())
			format = PageFormat.PORTRAIT;
		    PrintUtilities printHelper = new PrintUtilities(gC, format);
		    printHelper.print();
		}
	    };
        ok.addActionListener(actOk);
        panelButton.add(ok, BorderLayout.WEST);
	
        JButton cancel = new JButton("Cancel");
        ActionListener actCancel = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        };
        cancel.addActionListener(actCancel);
        panelButton.add(cancel, BorderLayout.EAST);

        panel.add(panelButton, BorderLayout.SOUTH);
    }

    public void itemStateChanged(ItemEvent evt) {
    }
}
