module InteSignalGUI =
   type ntrees = external, ptDCG = external, ptrepstr = external, ptident = external; 
   type objet_type = enum (typ_vide, typ_bte, typ_seg, typ_port, typ_port_ext, typ_text, typ_cadre, typ_text_param_proc, typ_text_nom_proc); 
   type mouse_type = enum (left, middle, right, ctrl_middle); 
   type function_type = enum (func_noopt, func_init, func_retiming, func_booleans2events, func_clockCalculus, func_trains, func_abstraction, func_booleanizing, func_flattening, func_serializing, func_gen_SIGNAL, func_poly2endo, func_gen_DCPlusSubFormat, 
                              func_gen_CANSI, func_gen_CPP, func_gen_JAVA, func_gen_Syndex, func_gen_Z3Z, func_unify, func_gen_abstract, func_profiling, func_end); 

   constant integer J_not_impl = 0, 
                    J_no_action = 1, 
                    J_creer = 2, 
                    J_creerbte = 3, 
                    J_creerproc = 4, 
                    J_creerbteexpr = 5, 
                    J_box_police = 6, 
                    J_creerlien = 7, 
                    J_creerport = 8, 
                    J_creerporte = 9, 
                    J_creerports = 10, 
                    J_cut = 11, 
                    J_move = 12, 
                    J_resize = 13, 
                    J_copy_graph = 14, 
                    J_justif = 15, 
                    J_delete = 16, 
                    J_in = 17, 
                    J_validparam = 18, 
                    J_cliqportnom = 19, 
                    J_confirm = 20, 
                    J_before = 21, 
                    J_refresh = 22, 
                    J_raz = 23, 
                    J_the_end = 24, 
                    J_halo = 25, 
                    J_encaps = 26, 
                    J_decaps = 27, 
                    J_undo = 28, 
                    J_copy_port = 29, 
                    J_root = 30, 
                    J_text_win = 31, 
                    J_help = 32, 
                    J_free33 = 33, 
                    J_creernode = 34, 
                    J_load = 35, 
                    J_parse = 36, 
                    J_saveAllRoots = 37, 
                    J_saveAllRootsAs = 38, 
                    J_saveAs = 39, 
                    J_unparseAs = 40, 
                    J_save_PS = 41, 
                    J_paste_graph = 42, 
                    J_specification = 43, 
                    J_creerfunc = 44, 
                    J_call_prov = 45, 
                    J_incl_prov = 46, 
                    J_selection = 47, 
                    J_pragm = 48, 
                    J_bte_map = 49, 
                    J_archi_compil = 50, 
                    J_load_Lib = 51, 
                    J_embed = 52, 
                    J_ch_typ_proc = 53, 
                    J_ch_typ_func = 54, 
                    J_end_map = 55, 
                    J_link_map = 56, 
                    J_mapp = 57, 
                    J_move_in_hierar = 58, 
                    J_grid = 59, 
                    J_displayDetails = 60, 
                    J_displayPortNames = 61, 
                    J_formalParameters = 62, 
                    J_localDeclaration = 63, 
                    J_comp_batch = 64, 
                    J_inOutDeclaration = 65, 
                    J_comp_inter = 66, 
                    J_port_police = 67, 
                    J_free68 = 68, 
                    J_free69 = 69, 
                    J_replaceIdent = 70, 
                    J_ch_typ_act = 71, 
                    J_creeraction = 72, 
                    J_save = 73, 
                    J_reset_window = 74, %J_save_t%
                    J_free75 = 75, 
                    J_free76 = 76, 
                    J_free77 = 77, 
                    J_free78 = 78, 
                    J_free79 = 79, 
                    J_nop = 80, %reset current action to no_action%
                    J_free81 = 81, 
                    J_free82 = 82, 
                    J_free83 = 83, 
                    J_free84 = 84, 
                    J_free85 = 85, 
                    J_free86 = 86, 
                    J_copy = 87, 
                    J_paste = 88, 
                    J_cut_graph = 89, 
                    J_free90 = 90, 
                    J_copy_Icon = 91, 
                    J_free92 = 92, 
                    J_ch_typ_node = 93, 
                    J_free94 = 94, 
                    J_info_Icon = 95, 
                    J_removeLib = 96, 
                    J_reloadLib = 97, 
                    J_copyPaste2newWindow = 98; 

   type action_type = enum (
	            C_not_impl, 
                    C_no_action, 
                    C_creer, 
                    C_creerbte, 
                    C_creerproc, 
                    C_creerbteexpr, 
                    C_box_police, 
                    C_creerlien, 
                    C_creerport, 
                    C_creerporte, 
                    C_creerports, %10%
                    C_cut, 
                    C_move, 
                    C_resize, 
                    C_copy_graph, 
                    C_justif, 
                    C_delete, 
                    C_in, 
                    C_validparam, 
                    C_cliqportnom, 
                    C_confirm, %20%
                    C_before, 
                    C_refresh, 
                    C_raz, 
                    C_the_end, 
                    C_halo, 
                    C_encaps, 
                    C_decaps, 
                    C_undo, 
                    C_copy_port, 
                    C_root, %30%
                    C_text_win, 
                    C_help, 
                    C_see_ports, 
                    C_creernode, 
                    C_load, 
                    C_parse, 
                    C_saveAllRoots, 
                    C_saveAllRootsAs, 
                    C_saveAs, 
                    C_unparseAs, %40%
                    C_save_PS, 
                    C_paste_graph, 
                    C_specification, 
                    C_creerfunc, 
                    C_call_prov, 
                    C_incl_prov, 
                    C_selection, 
                    C_pragmaDeclaration, 
                    C_bte_map, 
                    C_archi_compil, %50%
                    C_load_Lib, 
                    C_embed, 
                    C_ch_typ_proc, 
                    C_ch_typ_func, 
                    C_end_map, 
                    C_link_map, 
                    C_mapp, 
                    C_move_in_hierar, 
                    C_grid, 
                    C_displayDetails, %60%
                    C_displayPortNames, 
                    C_formalParameters, 
                    C_localDeclaration, 
                    C_comp_batch, 
                    C_inOutDeclaration, 
                    C_comp_inter, 
                    C_port_police, 
                    C_free68, 
                    C_free69, 
                    C_replaceIdent, %70%
                    C_ch_typ_act, 
                    C_creeraction, 
                    C_save, 
                    C_reset_window, 
                    C_free75, 
                    C_free76, 
                    C_free77,
                    C_free78, 
                    C_free79, 
                    C_nop, %80%
                    C_free81, 
                    C_free82, 
                    C_free83, 
                    C_free84, 
                    C_free85, 
                    C_free86, 
                    C_copy, 
                    C_paste, 
                    C_cut_graph, 
                    C_creerautomaton, %90%
                    C_copy_Icon, 
                    C_free92, 
                    C_ch_typ_node, 
                    C_free94, 
                    C_info_Icon, 
                    C_removeLib, 
                    C_reloadLib, 
                    C_copyPaste2newWindow
   
); 

   process GetMenuButton =
        ( ! action_type currentAction;
        )
      pragmas 
         Comment "Gets action code from Java window and converts it to Signal code"
      end pragmas
      (| currentAction := J2C(ReadMenuButton()) |)
      where 
      process ReadMenuButton =
           ( ! integer ButtonAction;
           )
         pragmas 
            Comment "Gets action code from Java window"
         end pragmas
      
      ; 
      process J2C =
           ( ? integer J_code;
             ! action_type C_code;
           )
         pragmas 
            Comment "Conversion from Java action codes to Signal action codes"
         end pragmas
         (| C_code := J_2_C_codes[J_code] |)
         where 
         constant [99]action_type J_2_C_codes = [
	      #C_not_impl,
              #C_no_action,
              #C_creer,
              #C_creerbte,
              #C_creerproc,
              #C_creerbteexpr,
              #C_box_police,
              #C_creerlien,
              #C_creerport,
              #C_creerporte,
              #C_creerports, %10%
              #C_cut,
              #C_move,
              #C_resize,
              #C_copy_graph,
              #C_justif,
              #C_delete,
              #C_in,
              #C_validparam,
              #C_cliqportnom,
              #C_confirm, %20%
              #C_before,
              #C_refresh,
              #C_raz,
              #C_the_end,
              #C_halo,
              #C_encaps,
              #C_decaps,
              #C_undo,
              #C_copy_port,
              #C_root, %30%
              #C_text_win,
              #C_help,
              #C_see_ports,
              #C_creernode,
              #C_load,
              #C_parse,
              #C_saveAllRoots,
              #C_saveAllRootsAs,
              #C_saveAs,
              #C_unparseAs, %40%
              #C_save_PS,
              #C_paste_graph,
              #C_specification,
              #C_creerfunc,
              #C_call_prov,
              #C_incl_prov,
              #C_selection,
              #C_pragmaDeclaration,
              #C_bte_map,
              #C_archi_compil, %50%
              #C_load_Lib,
              #C_embed,
              #C_ch_typ_proc,
              #C_ch_typ_func,
              #C_end_map,
              #C_link_map,
              #C_mapp,
              #C_move_in_hierar,
              #C_grid,
              #C_displayDetails, %60%
              #C_displayPortNames,
              #C_formalParameters,
              #C_localDeclaration,
              #C_comp_batch,
              #C_inOutDeclaration,
              #C_comp_inter,
              #C_port_police,
              #C_free68,
              #C_free69,
              #C_replaceIdent, %70%
              #C_ch_typ_act,
              #C_creeraction,
              #C_save,
              #C_reset_window,
              #C_free75,
              #C_free76,
              #C_free77,
              #C_free78,
              #C_free79,
              #C_nop, %80%
              #C_free81,
              #C_free82,
              #C_free83,
              #C_free84,
              #C_free85,
              #C_free86,
              #C_copy,
              #C_paste,
              #C_cut_graph,
              #C_creerautomaton,  %90%
              #C_copy_Icon,
              #C_free92,
              #C_ch_typ_node,
              #C_free94,
              #C_info_Icon,
              #C_removeLib,
              #C_reloadLib,
	      #C_copyPaste2newWindow];
         end
      ;
      end
   ; 
   process loadFile =
        ( ? integer J_action; 
            boolean isGraphic;
	  ! boolean successfulLoading
        )
        spec (| J_action ^= isGraphic  ^= successfulLoading |)
      pragmas 
         Comment "Java dialogue for loading files"
                 "atomic action for Signal manager"
      end pragmas
   
   ; 
   action PostscriptPrint =
        ( )
      pragmas 
         Comment "Postscript current graph output"
                 "atomic action for Signal manager"
      end pragmas
   
   ; 
   process displayConfirm =
        ( ? integer J_action;
        )
      pragmas 
         Comment "Java dialogue for saving or loading files"
                 "atomic action for Signal manager"
      end pragmas
   
   ; 
   action quitApplication =
        ( )
      pragmas 
         Comment ""
      end pragmas
   
   ; 
   process saveFile =
        ( ? integer J_action; 
            boolean isGraphic;
        )
        spec (| J_action ^= isGraphic |)
      pragmas 
         Comment "Java dialogue for saving files"
                 "atomic action for Signal manager"
      end pragmas
   
   ; 
   process changeModelCat =
        ( ? ntrees t; 
            action_type S;
        )
        spec (| t ^= S |)
   
   ; 
   function getCurrentModel =
        ( ! ntrees currentModel;
        )
   
   ; 
   process DISPLAYING_DETAILS =
        ( ? boolean E;
        )
   
   ; 
   process DISPLAYING_NAMES =
        ( ? boolean E;
        )
   
   ; 
   process DISPLAYING_POLICE =
        ( ? action_type POLICE;
        )
   
   ; 
   action razSelectBuf =
        ( )
   
   ; 
   process getDetailState =
        ( ! boolean showDetail;
        )
   
   ; 
   process getNamesState =
        ( ! boolean showNames;
        )
   
   ; 
   process CONFIRMING =
        ( ! action_type CONFIRM;
        )
      pragmas 
         Comment "Revoir: Fait beaucoup trop de choses"
      end pragmas
   
   ; 
   action CALLING_PROVER =
        ( )
   
   ; 
   action BUILDING_RESOLV =
        ( )
   
   ; 
   action HELPMESS =
        ( )
   
   ; 
   action UNDOING =
        ( )
   
   ; 
   action REFRESHING =
        ( )
   
   ; 
   action WINDOW_TEXTING =
        ( )
   
   ; 
   process seeingParam =
        ( ? ntrees p;
        )
   
   ; 
   process seeingLocDecl =
        ( ? ntrees p;
        )
   
   ; 
   action DISPLAYING_PRAGMAS =
        ( )
   
   ; 
   process CREATING_SPEC =
        ( ? ntrees p;
        )
   
   ; 
   process getSelectedProc =
        ( ! ntrees p;
        )
   
   ; 
   process seeingInOut =
        ( ? ntrees p;
        )
   
   ; 
   action DISPLAYINGINFO_ICON =
        ( )
   
   ; 
   action removeLib =
        ( )
   
   ; 
   action reloadLib =
        ( )
   
   ;
end %InteSignalGUI%; 
