/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
//
//    Décompilation des arbres Signal
//    ---------------------------------
// Ce module parcourt les arbres Signal pour les afficher : 
//     - soit dans la fenêtre graphique (le canvas); dans ce cas, c'est une 
//       décompilation graphique, le module va donc aussi rechercher les
//       informations graphiques (boites, liens...)
//     - soit dans les fenêtres d'édition textuelle; dans ce cas, il ne va pas
//       rechercher les informations graphiques 
// Dans tous les cas, il fait appel au décompilateur textuel de Signal (print)

class SignalDisplaying{

#include "SignalDisplaying_m.h"
#include "SignalDisplaying_g.h"

 private:
  char signalDecl[20];
  char signalExpr[20];
  char signalProfile[20];
  char signalPragmas[20];
  char signalExternGraph[25];
  
  // titles for the textual windows


  /*  static const char signalDecl[20] = " Signal declaration"; 
  static const char signalExpr[20] = " Signal expression"; 
  static const char signalProfile[20] = " Signal profile"; 
  static const char signalPragmas[20] = " Signal pragmas"; 
  static const char signalExternGraph[25] = " Signal external graph";
  */
  /*
    static const char signalDecl[] = " Signal declaration"; 
    static const char signalExpr[] = " Signal expression"; 
    static const char signalProfile[] = " Signal profile"; 
    static const char signalPragmas[] = " Signal pragmas"; 
    static const char signalExternGraph[] = " Signal external graph"; 
  */

  ptGraphicTablesManager the_graphicTablesManager;
  ptGraphicTrees the_graphicalTrees;
  ptMessage the_messageTool;

  ptDrawing pDraw;
  ptCurrentObjectsManager pCurObjManager;

  char      tab[5];
  int       car_port[2];  //largeur et hauteur d un caractere de port
  int       car_box[2];  //largeur et hauteur d un caractere de box
  int       lg_cadre, ht_cadre, ht_bte, x_bte, y_bte, taille_bte;
  int       x_port, y_port, ou; // variables set by the method afficher_port and used
  //by afficher_rec and afficher_chemin 
  int       nb_fois;/* entier qui vaut 0 pour l'affichage du premier
		       segment d'un lien : on prend les coordonnees du port
		       comme premieres coordonnees de ce segment : evite les
		       problemes d'arrondi lorsque fact_ech est different de 1.*/
  boolean  affich_nom_port;// if true, the port names are displayed in the canvas 
  boolean  force; // if true, all the text is displayed in the boxes, if possible 
  boolean  affich_sav; // used to save the value of affich_nom_port
  typcoord mil_cadre; 
  ptrepbuf filebuf;
  tab_chaine stock_chaine; /* type tab_chaine défini dans sysfile_type.h */
};

