/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
#ifndef __CEXTRACT__
#if __STDC__

private:
boolean rout_port_port (ntrees port_a, ntrees port_b, boolean ext_a, boolean ext_b );
void get_coord_seg_port (ntrees arb_port, int typ_p, int *xseg, int *yseg );
void gener_coord_rout_port ( ntrees p_rout, boolean port_ext, int *p_x, int *p_y, int *sens_p);
boolean depl_bte_chemins ( int bte, typcoord *p_bougetail, boolean force );
void cherch_segs_coupe_bte ( int bte, ntrees l_segs );
boolean rout_ports_lies_encaps ( int bte, ntrees arb_port_bte, ntrees arb_port_diff, ntrees l_no_ports_lies, ntrees l_bte_enc, boolean intern );
boolean rout_ports_bte_encaps ( int bte, ntrees l_bte_enc, ntrees l_n_p_d_e, boolean intern );
void detr_liens_ports_encaps ( int bte, ntrees l_bte_enc, boolean intern );
void verif_lseg ( ntrees lseg, boolean intern );
boolean depl_seg ( int obj, typcoord *vcoord, int obj1, typcoord *vcoord1, int obj2, typcoord *vcoord2, boolean prec, typcoord *p_bougetail );
boolean depl_seg_routage ( int obj, typcoord *vcoord, int port, boolean intern, typcoord *p_bougetail );
boolean depl_seg_chem_mult ( int obj, typcoord *tcoord );
ntrees createListSeg ( typcoord *tcoord, int nbcoord, int pt_neg );
ntrees destr_seg ( int seg );
void ajout_seg_p ( ntrees seg_pred, ntrees nouv_seg );
void couper_seg ( pt_seg seg, typcoord ext, int direc_seg );
void nouv_chemin ( int lien, ntrees ch );
void enlever_liens_segs ( ntrees ch, boolean intern );
void couper_chemin ( int pt_neg, int pt_posi, int *nbcoord, typcoord *tcoord, int seg );
void createchemin (int pt_neg, int pt_posi, int nbcoord, typcoord *tcoord );
void detruire_chemin (ntrees ch, boolean intern );
void detruire_liens (ntrees p_gra, int typ_obj );
void modifier_chemin (int pt_neg, int nbcoord, typcoord *tcoord );
void detruire_chemin_restant (ntrees arb_bte, boolean detruit_port );
void createlien_direct (ntrees port_a, ntrees port_b, boolean ext_a, boolean ext_b );
boolean recouv_lien (int pt_neg, int pt_posi, int *nbcoord, typcoord *tcoord, int direc_seg, boolean autoRouting);
boolean trans_ext_chemins (ntrees prem_port, int cpt_port, typcoord *newcoord, boolean xmod, typcoord *p_bougetail, boolean force );
boolean trans_int_chemins (ntrees arb_bte, ntrees prem_port, int cpt_port, typcoord *newcoord );
boolean lancer_routage (boolean invers, int x1, int y1, int sens1, int x2, int y2, int sens2, typcoord *tcoord, int *nbcoord, int pt_neg, int *noseg );

#endif /* __STDC__ */
#endif /* __CEXTRACT__ */
